/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.statistik.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="STATISTIK_LAUF.Status",
     query="SELECT o FROM StatistikLauf o WHERE o.status = ?1 ORDER by o.zeitpunktDesLaufs ASC",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STATISTIK_LAUF.Wahl",
     query="SELECT o FROM StatistikLauf o WHERE o.wahl=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STATISTIK_LAUF.WahlterminNichtWahlAusloeser",
     query="SELECT o FROM StatistikLauf o WHERE o.wahltermin=?1 AND o.wahl IS NULL AND o.ausloeser=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STATISTIK_LAUF.WahlterminNichtWahl",
     query="SELECT o FROM StatistikLauf o WHERE o.wahltermin=?1 AND o.wahl IS NULL",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "STATISTIK_LAUF")
// @javax.persistence.IdClass(StatistikLaufPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class StatistikLauf
extends AbstractStatistikLauf
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public StatistikLauf() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public StatistikLauf(StatistikLauf original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "statistik_lauf_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "StatistikLauf")
    @javax.persistence.TableGenerator(name = "StatistikLauf", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "StatistikLauf", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient StatistikLaufPK pkCache;

  @Override
  public StatistikLaufPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new StatistikLaufPK(getId());
    }

    return pkCache;
  }

  public static <E extends StatistikLauf> java.util.Map<StatistikLaufPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<StatistikLaufPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends StatistikLauf> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedAusloeser = false;
          hasChangedBeschreibung = false;
          hasChangedEndeDesLaufs = false;
          hasChangedStartDesLaufs = false;
          hasChangedStatus = false;
          hasChangedZeitpunktDesLaufs = false;
  
      hasChangedWahltermin = false;
        hasChangedWahl = false;
  

        
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "AUSLOESER", nullable = StatistikLaufConstants.AUSLOESER_NULLABLE, length=StatistikLaufConstants.AUSLOESER_MAX_LENGTH)
        
  protected java.lang.String ausloeser =  null;

  @javax.persistence.Transient
  protected boolean hasChangedAusloeser = false;

  public boolean hasChangedAusloeser(){
    return hasChangedAusloeser;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertAusloeser = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenAusloeser;
  
  /**
   * 
   *
   * getter for STATISTIK_LAUF.AUSLOESER
   */
    @Override   public  java.lang.String getAusloeser() {
        return ausloeser;
      }

  /**
   * 
   *
   * setter for STATISTIK_LAUF.AUSLOESER
   *
   * @param ausloeser
   */
  @Override   public void setAusloeser( java.lang.String ausloeser) {

       resetTkCache();
                  
                          java.lang.String ausloeserInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(ausloeser, StatistikLaufConstants.AUSLOESER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ausloeser
      , ausloeserInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAusloeser |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ausloeser");
      }


             if (!isSeitLadenVeraendertAusloeser) {
          isSeitLadenVeraendertAusloeser = thisAttributChanged;
         if (isSeitLadenVeraendertAusloeser){
           wertNachLadenAusloeser=this.ausloeser;
         }
       }
      

       this.ausloeser = ausloeserInternal;

         }

        
  @javax.persistence.Column(name = "BESCHREIBUNG", nullable = StatistikLaufConstants.BESCHREIBUNG_NULLABLE, length=StatistikLaufConstants.BESCHREIBUNG_MAX_LENGTH)
        
  protected java.lang.String beschreibung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBeschreibung = false;

  public boolean hasChangedBeschreibung(){
    return hasChangedBeschreibung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBeschreibung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBeschreibung;
  
  /**
   * 
   *
   * getter for STATISTIK_LAUF.BESCHREIBUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBeschreibung() {
        return beschreibung;
      }

  /**
   * 
   *
   * setter for STATISTIK_LAUF.BESCHREIBUNG
   *
   * @param beschreibung
   */
  @Override   public void setBeschreibung(@javax.annotation.Nullable  java.lang.String beschreibung) {

       resetTkCache();
                  
                          java.lang.String beschreibungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(beschreibung, StatistikLaufConstants.BESCHREIBUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.beschreibung
      , beschreibungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBeschreibung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("beschreibung");
      }


             if (!isSeitLadenVeraendertBeschreibung) {
          isSeitLadenVeraendertBeschreibung = thisAttributChanged;
         if (isSeitLadenVeraendertBeschreibung){
           wertNachLadenBeschreibung=this.beschreibung;
         }
       }
      

       this.beschreibung = beschreibungInternal;

         }

        
  @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ENDE_DES_LAUFS", nullable = StatistikLaufConstants.ENDE_DES_LAUFS_NULLABLE, precision=StatistikLaufConstants.ENDE_DES_LAUFS_PRECISION)
    
  protected java.util.Date endeDesLaufs =  null;

  @javax.persistence.Transient
  protected boolean hasChangedEndeDesLaufs = false;

  public boolean hasChangedEndeDesLaufs(){
    return hasChangedEndeDesLaufs;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertEndeDesLaufs = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenEndeDesLaufs;
  
  /**
   * 
   *
   * getter for STATISTIK_LAUF.ENDE_DES_LAUFS
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getEndeDesLaufs() {
              if (endeDesLaufs == null){
            return null;
          } else {
                          return endeDesLaufs;
          }
      }

  /**
   * 
   *
   * setter for STATISTIK_LAUF.ENDE_DES_LAUFS
   *
   * @param endeDesLaufs
   */
  @Override   public void setEndeDesLaufs(@javax.annotation.Nullable  java.util.Date endeDesLaufs) {

       resetTkCache();
                  java.util.Date endeDesLaufsInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(endeDesLaufs);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.endeDesLaufs
      , endeDesLaufsInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEndeDesLaufs |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("endeDesLaufs");
      }


             if (!isSeitLadenVeraendertEndeDesLaufs) {
          isSeitLadenVeraendertEndeDesLaufs = thisAttributChanged;
         if (isSeitLadenVeraendertEndeDesLaufs){
           wertNachLadenEndeDesLaufs=this.endeDesLaufs;
         }
       }
      

       this.endeDesLaufs = endeDesLaufsInternal;

         }

        
  @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "START_DES_LAUFS", nullable = StatistikLaufConstants.START_DES_LAUFS_NULLABLE, precision=StatistikLaufConstants.START_DES_LAUFS_PRECISION)
    
  protected java.util.Date startDesLaufs =  null;

  @javax.persistence.Transient
  protected boolean hasChangedStartDesLaufs = false;

  public boolean hasChangedStartDesLaufs(){
    return hasChangedStartDesLaufs;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStartDesLaufs = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenStartDesLaufs;
  
  /**
   * 
   *
   * getter for STATISTIK_LAUF.START_DES_LAUFS
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getStartDesLaufs() {
              if (startDesLaufs == null){
            return null;
          } else {
                          return startDesLaufs;
          }
      }

  /**
   * 
   *
   * setter for STATISTIK_LAUF.START_DES_LAUFS
   *
   * @param startDesLaufs
   */
  @Override   public void setStartDesLaufs(@javax.annotation.Nullable  java.util.Date startDesLaufs) {

       resetTkCache();
                  java.util.Date startDesLaufsInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(startDesLaufs);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.startDesLaufs
      , startDesLaufsInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStartDesLaufs |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("startDesLaufs");
      }


             if (!isSeitLadenVeraendertStartDesLaufs) {
          isSeitLadenVeraendertStartDesLaufs = thisAttributChanged;
         if (isSeitLadenVeraendertStartDesLaufs){
           wertNachLadenStartDesLaufs=this.startDesLaufs;
         }
       }
      

       this.startDesLaufs = startDesLaufsInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = StatistikLaufConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.statistik.entity.StatistikLaufStatus status =  null;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.statistik.entity.StatistikLaufStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for STATISTIK_LAUF.STATUS
   */
    @Override   public  de.ivu.elect.business.statistik.entity.StatistikLaufStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for STATISTIK_LAUF.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.statistik.entity.StatistikLaufStatus status) {

       resetTkCache();
                  de.ivu.elect.business.statistik.entity.StatistikLaufStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ZEITPUNKT_DES_LAUFS", nullable = StatistikLaufConstants.ZEITPUNKT_DES_LAUFS_NULLABLE, precision=StatistikLaufConstants.ZEITPUNKT_DES_LAUFS_PRECISION)
    
  protected java.util.Date zeitpunktDesLaufs =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZeitpunktDesLaufs = false;

  public boolean hasChangedZeitpunktDesLaufs(){
    return hasChangedZeitpunktDesLaufs;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertZeitpunktDesLaufs = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenZeitpunktDesLaufs;
  
  /**
   * 
   *
   * getter for STATISTIK_LAUF.ZEITPUNKT_DES_LAUFS
   */
    @Override   public  java.util.Date getZeitpunktDesLaufs() {
              if (zeitpunktDesLaufs == null){
            return null;
          } else {
                          return zeitpunktDesLaufs;
          }
      }

  /**
   * 
   *
   * setter for STATISTIK_LAUF.ZEITPUNKT_DES_LAUFS
   *
   * @param zeitpunktDesLaufs
   */
  @Override   public void setZeitpunktDesLaufs( java.util.Date zeitpunktDesLaufs) {

       resetTkCache();
                  java.util.Date zeitpunktDesLaufsInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(zeitpunktDesLaufs);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zeitpunktDesLaufs
      , zeitpunktDesLaufsInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZeitpunktDesLaufs |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zeitpunktDesLaufs");
      }


             if (!isSeitLadenVeraendertZeitpunktDesLaufs) {
          isSeitLadenVeraendertZeitpunktDesLaufs = thisAttributChanged;
         if (isSeitLadenVeraendertZeitpunktDesLaufs){
           wertNachLadenZeitpunktDesLaufs=this.zeitpunktDesLaufs;
         }
       }
      

       this.zeitpunktDesLaufs = zeitpunktDesLaufsInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Wahltermin
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLTERMIN_ID", referencedColumnName="WAHLTERMIN_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahltermin wahltermin;

  /**
   * 
   */
  @Override
  public void setWahltermin( de.ivu.elect.business.wahl.entity.Wahltermin wahltermin){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahltermin
    , wahltermin);

    attributeChanged |= thisAttributChanged;

    hasChangedWahltermin |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahltermin");
    }

    this.wahltermin = wahltermin;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahltermin getWahltermin(){
    return this.wahltermin;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahltermin = false;

  public boolean hasChangedWahltermin(){
    return hasChangedWahltermin;
  }

  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl(@javax.annotation.Nullable  de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("StatistikLauf:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(StatistikLauf other){
                             other.ausloeser = this.ausloeser;
                                other.beschreibung = this.beschreibung;
                                other.endeDesLaufs = this.endeDesLaufs;
                                other.startDesLaufs = this.startDesLaufs;
                                other.status = this.status;
                                other.zeitpunktDesLaufs = this.zeitpunktDesLaufs;
           
  other.setWahltermin(this.getWahltermin());
  other.setWahl(this.getWahl());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(StatistikLauf.class)){
        copyEntityAttributesUsingSetter((StatistikLauf) other.castTo(StatistikLauf.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von StatistikLauf: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(StatistikLauf other){
               other.setAusloeser(this.ausloeser);
                  other.setBeschreibung(this.beschreibung);
                  other.setEndeDesLaufs(this.endeDesLaufs);
                  other.setStartDesLaufs(this.startDesLaufs);
                  other.setStatus(this.status);
                  other.setZeitpunktDesLaufs(this.zeitpunktDesLaufs);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(StatistikLauf other){
                       if (hasChangedAusloeser) {
        other.setAusloeser(this.ausloeser);
      }
                             if (hasChangedBeschreibung) {
        other.setBeschreibung(this.beschreibung);
      }
                             if (hasChangedEndeDesLaufs) {
        other.setEndeDesLaufs(this.endeDesLaufs);
      }
                             if (hasChangedStartDesLaufs) {
        other.setStartDesLaufs(this.startDesLaufs);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedZeitpunktDesLaufs) {
        other.setZeitpunktDesLaufs(this.zeitpunktDesLaufs);
      }
             }





    @javax.persistence.Transient
    private transient StatistikLaufTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public StatistikLaufTK getStatistikLaufTK(){
    if (tkCache==null) {
    tkCache = new StatistikLaufTK(

getAusloeser()
, getZeitpunktDesLaufs()
,   (getWahl() == null) ? null : getWahl().getWahlTK()
,   (getWahltermin() == null) ? null : getWahltermin().getWahlterminTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getStatistikLaufTK();
    }

  @Override
  public StatistikLaufUK getUk(){
    return getStatistikLaufUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return StatistikLauf.class;
  }

public StatistikLaufUK getStatistikLaufUK(){

   return  new StatistikLaufUK(



  );
}

  @javax.persistence.Transient
  private transient StatistikLaufProperties properties;

  public StatistikLaufProperties getProperties(){
    if (properties == null) {
      properties = new StatistikLaufProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public StatistikLaufProperties getStatistikLaufProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return StatistikLaufConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(StatistikLaufConstants.MESSAGE_KEY_AUSLOESER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StatistikLaufConstants.MESSAGE_KEY_AUSLOESER_EINZAHL);

        ausloeser =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StatistikLaufConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StatistikLaufConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL);

        beschreibung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StatistikLaufConstants.MESSAGE_KEY_ENDE_DES_LAUFS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StatistikLaufConstants.MESSAGE_KEY_ENDE_DES_LAUFS_EINZAHL);

        endeDesLaufs =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StatistikLaufConstants.MESSAGE_KEY_START_DES_LAUFS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StatistikLaufConstants.MESSAGE_KEY_START_DES_LAUFS_EINZAHL);

        startDesLaufs =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StatistikLaufConstants.MESSAGE_KEY_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StatistikLaufConstants.MESSAGE_KEY_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.statistik.entity.StatistikLaufStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StatistikLaufConstants.MESSAGE_KEY_ZEITPUNKT_DES_LAUFS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StatistikLaufConstants.MESSAGE_KEY_ZEITPUNKT_DES_LAUFS_EINZAHL);

        zeitpunktDesLaufs =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertAusloeser) {
      result.put(StatistikLaufConstants.MESSAGE_KEY_AUSLOESER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenAusloeser , ausloeser));
    }
                            if (isSeitLadenVeraendertBeschreibung) {
      result.put(StatistikLaufConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBeschreibung , beschreibung));
    }
                            if (isSeitLadenVeraendertEndeDesLaufs) {
      result.put(StatistikLaufConstants.MESSAGE_KEY_ENDE_DES_LAUFS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenEndeDesLaufs , endeDesLaufs));
    }
                            if (isSeitLadenVeraendertStartDesLaufs) {
      result.put(StatistikLaufConstants.MESSAGE_KEY_START_DES_LAUFS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenStartDesLaufs , startDesLaufs));
    }
                            if (isSeitLadenVeraendertStatus) {
      result.put(StatistikLaufConstants.MESSAGE_KEY_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                            if (isSeitLadenVeraendertZeitpunktDesLaufs) {
      result.put(StatistikLaufConstants.MESSAGE_KEY_ZEITPUNKT_DES_LAUFS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenZeitpunktDesLaufs , zeitpunktDesLaufs));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertAusloeser = false;
      wertNachLadenAusloeser = null;
                          isSeitLadenVeraendertBeschreibung = false;
      wertNachLadenBeschreibung = null;
                          isSeitLadenVeraendertEndeDesLaufs = false;
      wertNachLadenEndeDesLaufs = null;
                          isSeitLadenVeraendertStartDesLaufs = false;
      wertNachLadenStartDesLaufs = null;
                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                          isSeitLadenVeraendertZeitpunktDesLaufs = false;
      wertNachLadenZeitpunktDesLaufs = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "STATISTIK_LAUF";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "StatistikLauf";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ausloeser, this, StatistikLaufConstants.MESSAGE_KEY_AUSLOESER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StatistikLaufConstants.AUSLOESER_MAX_LENGTH , 1 ,  ausloeser, this, StatistikLaufConstants.MESSAGE_KEY_AUSLOESER_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StatistikLaufConstants.BESCHREIBUNG_MAX_LENGTH ,  beschreibung, this, StatistikLaufConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, validationResult);
                                                                                                                                                                             de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, StatistikLaufConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(zeitpunktDesLaufs, this, StatistikLaufConstants.MESSAGE_KEY_ZEITPUNKT_DES_LAUFS_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
